关闭

WSAStartup()函数以及DLL的加载

106人阅读 评论(0) 收藏 举报
分类:
本节讲解 Windows 下 DLL 的加载,学习 Linux Socket 的读者可以跳过。
WinSock(Windows Socket)编程依赖于系统提供的动态链接库(DLL),有两个版本:
  • 较早的DLL是 wsock32.dll,大小为 28KB,对应的头文件为 winsock1.h;
  • 最新的DLL是 ws2_32.dll,大小为 69KB,对应的头文件为 winsock2.h。

几乎所有的 Windows 操作系统都已经支持 ws2_32.dll,包括个人操作系统 Windows 95 OSR2、Windows 98、Windows Me、Windows 2000、XP、Vista、Win7、Win8、Win10 以及服务器操作系统 Windows NT 4.0 SP4、Windows Server 2003、Windows Server 2008 等,所以你可以毫不犹豫地使用最新的 ws2_32.dll。

使用DLL之前必须把DLL加载到当前程序,你可以在编译时加载,也可以在程序运行时加载,《C语言高级教程》中讲到了这两种加载方式,请猛击:动态链接库DLL的加载:隐式加载(载入时加载)和显式加载(运行时加载)

这里使用#pragma命令,在编译时加载:
#pragma comment (lib, "ws2_32.lib")

WSAStartup() 函数

使用DLL之前,还需要调用 WSAStartup() 函数进行初始化,以指明 WinSock 规范的版本,它的原型为:
int WSAStartup(WORD wVersionRequested, LPWSADATA lpWSAData);
wVersionRequested 为 WinSock 规范的版本号,低字节为主版本号,高字节为副版本号(修正版本号);lpWSAData 为指向 WSAData 结构体的指针。

关于 WinSock 规范

WinSock 规范的最新版本号为 2.2,较早的有 2.1、2.0、1.1、1.0,ws2_32.dll 支持所有的规范,而 wsock32.dll 仅支持 1.0 和 1.1。

wsock32.dll 已经能够很好的支持 TCP/IP 通信程序的开发,ws2_32.dll 主要增加了对其他协议的支持,不过建议使用最新的 2.2 版本。

wVersionRequested 参数用来指明我们希望使用的版本号,它的类型为 WORD,等价于 unsigned short,是一个整数,所以需要用 MAKEWORD() 宏函数对版本号进行转换。例如:
MAKEWORD(1, 2);  //主版本号为1,副版本号为2,返回 0x0201
MAKEWORD(2, 2);  //主版本号为2,副版本号为2,返回 0x0202

关于 WSAData 结构体

WSAStartup() 函数执行成功后,会将与 ws2_32.dll 有关的信息写入 WSAData 结构体变量。WSAData 的定义如下:
  1. typedef struct WSAData {
  2. WORD wVersion; //ws2_32.dll 建议我们使用的版本号
  3. WORD wHighVersion; //ws2_32.dll 支持的最高版本号
  4. //一个以 null 结尾的字符串,用来说明 ws2_32.dll 的实现以及厂商信息
  5. char szDescription[WSADESCRIPTION_LEN+1];
  6. //一个以 null 结尾的字符串,用来说明 ws2_32.dll 的状态以及配置信息
  7. char szSystemStatus[WSASYS_STATUS_LEN+1];
  8. unsigned short iMaxSockets; //2.0以后不再使用
  9. unsigned short iMaxUdpDg; //2.0以后不再使用
  10. char FAR *lpVendorInfo; //2.0以后不再使用
  11. } WSADATA, *LPWSADATA;
最后3个成员已弃之不用,szDescription 和 szSystemStatus 包含的信息基本没有实用价值,读者只需关注前两个成员即可。请看下面的代码:
  1. #include <stdio.h>
  2. #include <winsock2.h>
  3. #pragma comment (lib, "ws2_32.lib")
  4. int main(){
  5. WSADATA wsaData;
  6. WSAStartup( MAKEWORD(2, 2), &wsaData);
  7. printf("wVersion: %d.%d\n", LOBYTE(wsaData.wVersion), HIBYTE(wsaData.wVersion));
  8. printf("wHighVersion: %d.%d\n", LOBYTE(wsaData.wHighVersion), HIBYTE(wsaData.wHighVersion));
  9. printf("szDescription: %s\n", wsaData.szDescription);
  10. printf("szSystemStatus: %s\n", wsaData.szSystemStatus);
  11. return 0;
  12. }
运行结果:
wVersion: 2.2
wHighVersion: 2.2
szDescription: WinSock 2.0
szSystemStatus: Running

ws2_32.dll 支持的最高版本为 2.2,建议使用的版本也是 2.2。

综上所述:WinSock 编程的第一步就是加载 ws2_32.dll,然后调用 WSAStartup() 函数进行初始化,并指明要使用的版本号。
0
0

查看评论
* 以上用户言论只代表其个人观点,不代表CSDN网站的观点或立场
    个人资料
    • 访问:298225次
    • 积分:12202
    • 等级:
    • 排名:第1178名
    • 原创:984篇
    • 转载:12篇
    • 译文:0篇
    • 评论:21条
    最新评论